
#Include Once "windows.bi"
#include once "win/richedit.bi"
#include once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "inc/http.bi"
#Include Once "inc/win_clipboard.bi"
#Include Once "inc/win_unicode.bi"
#Include Once "inc/xml.bi"

#Include Once "fbedit/raedit.bi"
#Include Once "fbedit/addins.bi"

#Include Once "nopasteplugin.bi"


'#Include Once "debug.bi"


Declare Sub UpdateThread(param As Any Ptr)
Declare Sub UpdControls(ByVal hWin As HWND)


Sub TranslateMenu(ByVal hMenu As HMENU)
	Dim mii As MENUITEMINFO
	Dim tmpStr As String
	Dim cnt As Integer = GetMenuItemCount(hMenu)
	mii.cbSize = SizeOf(MENUITEMINFO)
	For q As Integer = 0 To cnt-1
		mii.fMask = MIIM_ID or MIIM_SUBMENU or MIIM_FTYPE
		GetMenuItemInfo(hMenu, q, TRUE, @mii)
		If mii.hSubMenu <> 0 Then TranslateMenu(mii.hSubMenu)
		If (mii.fType And MFT_SEPARATOR) <> 0 Then Continue For
		mii.fMask = MIIM_STRING
		tmpStr = lpFunctions->FindString(lpData->hLangMem, "NoPaste", Str(mii.wID))
		If tmpStr = "" Then Continue For
		mii.dwTypeData = StrPtr(tmpStr)
		mii.cch = Len(tmpStr)+1
		SetMenuItemInfo(hMenu, q, TRUE, @mii)
	Next
End Sub


Sub AddToMenu(ByVal id As Integer, ByVal menu As UInteger, ByVal title As String)
	Dim mii As MENUITEMINFO
	mii.cbSize = SizeOf(MENUITEMINFO)
	mii.fMask = MIIM_SUBMENU
	GetMenuItemInfo(lpHANDLES->hmenu, menu, FALSE, @mii)
	AppendMenu(mii.hSubMenu, MF_STRING, id, StrPtr(title))
End Sub

Sub AddToAccelerator(ByVal fvirt As Integer, ByVal akey As Integer, ByVal id As Integer)
	Dim nAccel As Integer
	Dim acl(500) As ACCEL

	nAccel = CopyAcceleratorTable(lpHandles->haccel, NULL, 0)
	CopyAcceleratorTable(lpHandles->haccel, @acl(0), nAccel)
	DestroyAcceleratorTable(lpHandles->haccel)
	acl(nAccel).fVirt = fvirt
	acl(nAccel).key = akey
	acl(nAccel).cmd = id
	nAccel = nAccel+1
	lpHandles->haccel = CreateAcceleratorTable(@acl(0), nAccel)
End Sub


Sub UpdateAccelerator(ByVal fvirt As Integer, ByVal akey As Integer, ByVal id As Integer)
	Dim nAccel As Integer
	Dim acl(500) As ACCEL
	Dim q As Integer
	Dim w As Integer = 0

	nAccel = CopyAcceleratorTable(lpHandles->haccel, NULL, 0)
	CopyAcceleratorTable(lpHandles->haccel, @acl(0), nAccel)
	For q = 0 To nAccel - 1
		If acl(q).cmd = id Then
			If akey = 0 Then
				nAccel -= 1
				For w = q To nAccel-1
					acl(q) = acl(q+1)
				Next
				w = 2
			Else
				acl(q).fVirt = fvirt
				acl(q).key = akey
				acl(q).cmd = id
				w = 1
			End If
		End If
	Next
	If w = 0 And akey <> 0 Then
		acl(nAccel).fVirt = fvirt
		acl(nAccel).key = akey
		acl(nAccel).cmd = id
		nAccel = nAccel+1
		w = 3
	End If
	If w <> 0 Then
		DestroyAcceleratorTable(lpHandles->haccel)
		lpHandles->haccel = CreateAcceleratorTable(@acl(0), nAccel)
	End If
End Sub

Function TranslateModifiers(ByVal modifiers As Integer) As Integer
	Dim q As Integer = 0
	If modifiers And HOTKEYF_ALT Then q = q Or FALT
	If modifiers And HOTKEYF_SHIFT Then q = q Or FSHIFT
	If modifiers And HOTKEYF_CONTROL Then q = q Or FCONTROL
	Return q
End Function

Function TMsgBox(ByVal hWin As HWND, ByRef msg As String, ByRef tMsg As String = "", ByRef title As String = "NoPaste plugin", ByRef tTitle As String = "nopaste_plugin", ByVal param As Integer = 0) As Integer
	Dim tmpTitle As String = ""
	Dim tmpMsg As String = ""
	If tTitle <> "" Then tmpTitle = lpFunctions->FindString(lpData->hLangMem, "NoPaste", tTitle)
	If tmpTitle = "" Then tmpTitle = title
	If tMsg <> "" Then tmpMsg = lpFunctions->FindString(lpData->hLangMem, "NoPaste", tMsg)
	If tmpMsg = "" Then tmpMsg = msg
	Return MessageBox(hWin, StrPtr(tmpMsg), StrPtr(tmpTitle), param)
End Function

Function TT(ByRef msg As String, ByRef tMsg As String = "") As String
	Dim tmpMsg As String = ""
	If tMsg <> "" Then tmpMsg = lpFunctions->FindString(lpData->hLangMem, "NoPaste", tMsg)
	If tmpMsg = "" Then Return msg Else Return tmpMsg
End Function

Function CheckHotkey(ByVal vkey As Integer, ByVal modifiers As Integer, ByVal id As Integer) As Integer
	Dim nAccel As Integer
	Dim acl(500) As ACCEL
	Dim tmpKey As Integer
	Dim mods As Integer = TranslateModifiers(modifiers)
	Dim key2 As integer
	Dim mods2 As Integer
	
	nAccel = CopyAcceleratorTable(lpHandles->haccel, NULL, 0)
	CopyAcceleratorTable(lpHandles->haccel, @acl(0), nAccel)
	For q As Integer = 0 To nAccel - 1
		If acl(q).fVirt And FVIRTKEY Then
			If acl(q).cmd = id Then Continue For
			If vkey <> acl(q).key Then Continue For
			If mods <> (acl(q).fVirt And (FALT Or FSHIFT Or FCONTROL)) Then Continue For
		Else
			tmpKey = VkKeyScan(acl(q).key)
			If LoByte(tmpKey) = -1 And HiByte(tmpKey) = -1 Then Continue For
			If LoByte(tmpKey) <> vkey Then Continue For
			mods2 = acl(q).fVirt And (FALT Or FSHIFT Or FCONTROL)
			If HiByte(tmpKey) And 1 Then mods2 = mods2 Or FSHIFT
			If HiByte(tmpKey) And 2 Then mods2 = mods2 Or FCONTROL
			If HiByte(tmpKey) And 4 Then mods2 = mods2 Or FALT
			If mods2 <> mods Then Continue For
		End If
		Return 1
		
	Next
	Return 0
End Function


Function SettingsProc(ByVal hWin As HWND, ByVal uMsg As UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Dim q As Integer
	Dim tmpStr As String
	
	Select Case uMsg
		Case WM_INITDIALOG
			lpFunctions->TranslateAddinDialog(hWin, "NoPaste")
			tmpStr = TT("NoPaste settings", "1000")
			SetWindowText(hWin, StrPtr(tmpStr))
			CheckDlgButton(hWin, IDC_CHKUPDATES, IIf(Sett.updates <> 0, BST_CHECKED, BST_UNCHECKED))
			SendDlgItemMessage(hWin, IDC_HOTKEY, HKM_SETRULES, HKCOMB_NONE Or HKCOMB_S, HOTKEYF_CONTROL)
			SendDlgItemMessage(hWin, IDC_HOTKEY, HKM_SETHOTKEY, Sett.hotkey, 0)
			Select Case Sett.onUpload
				Case 0: CheckDlgButton(hWin, IDC_RBCHOOSE, BST_CHECKED)
				Case 1: CheckDlgButton(hWin, IDC_RBCLIPBOARD, BST_CHECKED)
				Case 2: CheckDlgButton(hWin, IDC_RBBROWSER, BST_CHECKED)
				Case 3: CheckDlgButton(hWin, IDC_RBBOTH, BST_CHECKED)
				Case Else: CheckDlgButton(hWin, IDC_RBCHOOSE, BST_CHECKED)
			End Select
			
		Case WM_CLOSE
			EndDialog(hWin, 0)
			
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDCANCEL
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
				Case IDOK
					Dim As Integer tmpHotkey
					tmpHotkey = SendDlgItemMessage(hWin, IDC_HOTKEY, HKM_GETHOTKEY, 0, 0)
					If LoByte(tmpHotkey) <> 0 Then
						If CheckHotkey(LoByte(tmpHotkey), HiByte(tmpHotkey), IDM_NOPASTE) <> 0 Then
							TMsgBox(hWin, "The choosen keyboard shortcut is already in use. Please choose another combination!", "key_in_use", "Error", "error", MB_OK Or MB_ICONWARNING)
							Exit Select
						End If
					End If
					Sett.hotkey = tmpHotkey
					If IsDlgButtonChecked(hWin, IDC_RBCHOOSE) = BST_CHECKED Then
						Sett.onUpload = 0
					ElseIf IsDlgButtonChecked(hWin, IDC_RBCLIPBOARD) = BST_CHECKED Then
						Sett.onUpload = 1
					ElseIf IsDlgButtonChecked(hWin, IDC_RBBROWSER) = BST_CHECKED Then
						Sett.onUpload = 2
					ElseIf IsDlgButtonChecked(hWin, IDC_RBBOTH) = BST_CHECKED Then
						Sett.onUpload = 3
					Else
						Sett.onUpload = 0
					EndIf
					If IsDlgButtonChecked(hWin, IDC_CHKUPDATES) = BST_UNCHECKED Then Sett.updates = 0 Else Sett.updates = 1
					UpdateAccelerator(TranslateModifiers(HiByte(Sett.hotkey)) Or FVIRTKEY or FNOINVERT, LoByte(Sett.hotkey), IDM_NOPASTE)
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
				Case IDC_UPDATE
					If tUpdate = 0 Then tUpdate = ThreadCreate(@UpdateThread, Cast(Any Ptr, 1))
					
			End Select
			
		Case Else
			Return FALSE
			
	End Select
	Return TRUE

End Function


Sub IndentComment(ByVal char As String,ByVal fUn As Boolean, ByVal editor As HWND)
	Dim ochrg As CHARRANGE
	Dim chrg As CHARRANGE
	Dim As Integer LnSt,LnEn,LnCnt,tmp,nmin,n,bm
	Dim buffer As String*128
	Const tabsize As Integer = 2
	Const expand As Integer = 0

	nmin=999
	SendMessage(editor,WM_SETREDRAW,FALSE,0)
	SendMessage(editor,REM_LOCKUNDOID,TRUE,0)
	SendMessage(editor,EM_EXGETSEL,0,Cast(LPARAM,@ochrg))
	chrg.cpMin=ochrg.cpMin
	chrg.cpMax=ochrg.cpMax
	SendMessage(editor,EM_HIDESELECTION,TRUE,0)
	LnSt=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMin)
	If chrg.cpMax>chrg.cpMin Then
		chrg.cpMax-=1
	EndIf
	LnEn=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMax)
	LnCnt=LnEn-LnSt
	If LnCnt Then
		ochrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
		ochrg.cpMax=SendMessage(editor,EM_LINEINDEX,LnEn,0)
		ochrg.cpMax=ochrg.cpMax+SendMessage(editor,EM_LINELENGTH,ochrg.cpMax,0)+1
	ElseIf ochrg.cpMin<>ochrg.cpMax Then
		If ochrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0) And ochrg.cpMax=SendMessage(editor,EM_LINEINDEX,LnEn+1,0) Then
			LnCnt=1
		EndIf
	EndIf
	Do While LnSt<=LnEn
		If fUn Then
			' Uncomment or Outdent
			If char=Chr(9) Then
				' Outdent
				chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
				chrg.cpMax=chrg.cpMin+1
				SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
				SendMessage(editor,EM_GETSELTEXT,0,Cast(LPARAM,@buffer))
				If buffer=Chr(9) Then
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,StrPtr("")))
					If lnCnt>0 Or chrg.cpMin<ochrg.cpMax Then
						ochrg.cpMax-=1
						If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
							ochrg.cpMin-=1
						EndIf
					EndIf
				Else
					tmp=tabsize
					While tmp
						chrg.cpMax=chrg.cpMin+tmp
						SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
						SendMessage(editor,EM_GETSELTEXT,0,Cast(LPARAM,@buffer))
						If buffer=Space(tmp) Then
							SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,StrPtr("")))
							If lnCnt>0 Or chrg.cpMax<=ochrg.cpMax Then
								ochrg.cpMax-=tmp
								If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
									ochrg.cpMin-=tmp
								EndIf
							ElseIf chrg.cpMax>ochrg.cpMax Then
								ochrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
								ochrg.cpMax=ochrg.cpMin
							EndIf
							Exit While
						EndIf
						tmp=tmp-1
					Wend
				EndIf
			Else
				' Uncomment
				buffer=Chr(127) & Chr(0)
				n=SendMessage(editor,EM_GETLINE,LnSt,Cast(LPARAM,@buffer))
				buffer[n]=0
				For tmp=0 To 127
					If buffer[tmp]<>VK_SPACE And buffer[tmp]<>VK_TAB And buffer[tmp]<>Asc("'") Then
						Exit For
					ElseIf buffer[tmp]=Asc("'") Then
						chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)+tmp
						chrg.cpMax=chrg.cpMin+1
						SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
						SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,StrPtr("")))
						If lnCnt>0 Or chrg.cpMin<ochrg.cpMax Then
							ochrg.cpMax-=1
							If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
								ochrg.cpMin-=1
							EndIf
						EndIf
						Exit For
					EndIf
				Next
			EndIf
		Else
			' Comment or Indent
			chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
			chrg.cpMax=chrg.cpMin
			SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
			If char=Chr(9) Then
				' Indent
				If expand Then
					buffer=Space(tabsize)
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,@buffer))
					ochrg.cpMax+=tabsize
					If LnCnt=0 Then
						ochrg.cpMin+=tabsize
					EndIf
				Else
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,@char))
					ochrg.cpMax+=1
					If LnCnt=0 Then
						ochrg.cpMin+=1
					EndIf
				EndIf
			Else
				' Comment
				bm=SendMessage(editor,REM_GETBOOKMARK,LnSt,0)
				If bm=1 Or bm=2 Then
					SendMessage(editor,REM_SETBOOKMARK,LnSt,0)
					SendMessage(editor,REM_SETDIVIDERLINE,LnSt,FALSE)
				EndIf
				buffer=Chr(127) & Chr(0)
				n=SendMessage(editor,EM_GETLINE,LnSt,Cast(LPARAM,@buffer))
				buffer[n]=0
				n=0
				For tmp=0 To 127
					If buffer[tmp]=VK_SPACE Then
						n+=1
					ElseIf buffer[tmp]=VK_TAB Then
						n+=tabsize
						n=(n\tabsize)*tabsize
					ElseIf buffer[tmp]=0 Then
						n=999
						Exit For
					Else
						Exit For
					EndIf
				Next
				If n<nmin Then
					nmin=n
				EndIf
			EndIf
		EndIf
		LnSt=LnSt+1
	Loop
	If fUn=0 And char="'" Then
		' Comment
		chrg.cpMin=ochrg.cpMin
		chrg.cpMax=ochrg.cpMax
		LnSt=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMin)
		If chrg.cpMax>chrg.cpMin Then
			chrg.cpMax=chrg.cpMax-1
		EndIf
		LnEn=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMax)
		LnCnt=LnEn-LnSt
		Do While LnSt<=LnEn
			buffer=String(128,0)
			buffer=Chr(127) & Chr(0)
			n=SendMessage(editor,EM_GETLINE,LnSt,Cast(LPARAM,@buffer))
			buffer[n]=0
			n=0
			For tmp=0 To 127
				If n=nmin Then
					chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)+tmp
					chrg.cpMax=chrg.cpMin
					SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,@char))
					If lnCnt>0 Or chrg.cpMin<ochrg.cpMax Then
						ochrg.cpMax+=1
						If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
							ochrg.cpMin+=1
						EndIf
					EndIf
					Exit For
				EndIf
				If buffer[tmp]=VK_SPACE Then
					n+=1
				ElseIf buffer[tmp]=VK_TAB Then
					n+=tabsize
					n=(n\tabsize)*tabsize
				ElseIf buffer[tmp]=0 Then
					Exit For
				EndIf
			Next
			LnSt=LnSt+1
		Loop
	EndIf
	SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@ochrg))
	SendMessage(editor,EM_HIDESELECTION,FALSE,0)
	SendMessage(editor,REM_LOCKUNDOID,FALSE,0)
	SendMessage(editor,WM_SETREDRAW,TRUE,0)
	SendMessage(editor,REM_REPAINT,0,0)
	SetFocus(editor)

End Sub





Function EditProc(ByVal hWin As HWND,ByVal uMsg As UINT,ByVal wParam As WPARAM,ByVal lParam As LPARAM) As Integer
	Dim pt As Point
	Dim chrg As CHARRANGE
	
	Select Case uMsg
		Case WM_CONTEXTMENU
			If lParam = -1 Then
				GetCaretPos(@pt)
				ClientToScreen(hWin, @pt)
				pt.x = pt.x+10
			Else
				pt.x = Cast(Short, LoWord(lParam))
				pt.y = Cast(Short, HiWord(lParam))
			EndIf
			TrackPopupMenu(GetSubMenu(hContextMenu,0), TPM_LEFTALIGN Or TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWinMenu, 0)
			Return 0
			
		Case WM_CHAR
			If SendMessage(GetParent(hWin),REM_GETMODE,0,0)=0 Then					' Mode Normal
				If wParam=VK_TAB Then																					' Indent / Outdent
					If (GetKeyState(VK_SHIFT) And &H80)<>0 Then
						IndentComment(Chr(9),TRUE, GetParent(hWin))
						Return 0
					Else
						SendMessage(GetParent(hWin), EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
						If chrg.cpMin <> chrg.cpMax Then
							IndentComment(Chr(9),FALSE, GetParent(hWin))
							Return 0
						End If
					EndIf
				EndIf
			End If
			
		Case WM_KEYUP
			If SendMessage(GetParent(hWin),REM_GETMODE,0,0)=0 Then					' Mode Normal
				If wParam = VK_F9 Then																				' Comment / Uncomment
					If (GetKeyState(VK_SHIFT) And &H80)<>0 Then
						IndentComment("'" & Chr(0), TRUE, GetParent(hWin))
						Return 0
					Else
						IndentComment("'" & Chr(0), FALSE, GetParent(hWin))
						Return 0
					EndIf
				End If
			End If
			
	End Select
	Return CallWindowProc(lpOldEditProc,hWin,uMsg,wParam,lParam)
End Function


Sub UpdMenu(ByVal hWin As HWND)
	Dim chrg as CHARRANGE
	Dim ena As Integer
	EnableMenuItem(hContextMenu, IDM_UNDO, MF_BYCOMMAND Or IIf(SendDlgItemMessage(hWin, IDC_RAEDIT, EM_CANUNDO, 0, 0), MF_ENABLED, MF_GRAYED))
	EnableMenuItem(hContextMenu, IDM_REDO, MF_BYCOMMAND Or IIf(SendDlgItemMessage(hWin, IDC_RAEDIT, EM_CANREDO, 0, 0), MF_ENABLED, MF_GRAYED))
	EnableMenuItem(hContextMenu, IDM_PASTE, MF_BYCOMMAND Or IIf(SendDlgItemMessage(hWin, IDC_RAEDIT, EM_CANPASTE, CF_TEXT, 0), MF_ENABLED, MF_GRAYED))
	SendDlgItemMessage(hWin, IDC_RAEDIT, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
	If chrg.cpMin = chrg.cpMax Then ena = MF_GRAYED Else ena = MF_ENABLED
	EnableMenuItem(hContextMenu, IDM_COPY, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_CUT, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_DELETE, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_BLOCKINDENT, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_BLOCKOUTDENT, MF_BYCOMMAND Or ena)
End Sub


Function FmtByID(ByVal id As Integer) As String
	Select Case id
		Case 0: return "abap"
		Case 1: return "actionscript"
		Case 2: return "actionscript3"
		Case 3: return "ada"
		Case 4: return "apache"
		Case 5: return "applescript"
		Case 6: return "apt_sources"
		Case 7: return "asm"
		Case 8: return "asp"
		Case 9: return "autoit"
		Case 10: return "avisynth"
		Case 11: return "bash"
		Case 12: return "basic4gl"
		Case 13: return "bibtex"
		Case 14: return "blitzbasic"
		Case 15: return "bnf"
		Case 16: return "boo"
		Case 17: return "bf"
		Case 18: return "c"
		Case 19: return "c_mac"
		Case 20: return "cill"
		Case 21: return "csharp"
		Case 22: return "cpp"
		Case 23: return "caddcl"
		Case 24: return "cadlisp"
		Case 25: return "cfdg"
		Case 26: return "klonec"
		Case 27: return "klonecpp"
		Case 28: return "cmake"
		Case 29: return "cobol"
		Case 30: return "cfm"
		Case 31: return "css"
		Case 32: return "d"
		Case 33: return "dcs"
		Case 34: return "delphi"
		Case 35: return "dff"
		Case 36: return "div"
		Case 37: return "dos"
		Case 38: return "dot"
		Case 39: return "eiffel"
		Case 40: return "email"
		Case 41: return "erlang"
		Case 42: return "fo"
		Case 43: return "fortran"
		Case 44: return "freebasic"
		Case 45: return "gml"
		Case 46: return "genero"
		Case 47: return "gettext"
		Case 48: return "groovy"
		Case 49: return "haskell"
		Case 50: return "hq9plus"
		Case 51: return "html4strict"
		Case 52: return "idl"
		Case 53: return "ini"
		Case 54: return "inno"
		Case 55: return "intercal"
		Case 56: return "io"
		Case 57: return "java"
		Case 58: return "java5"
		Case 59: return "javascript"
		Case 60: return "kixtart"
		Case 61: return "latex"
		Case 62: return "lsl2"
		Case 63: return "lisp"
		Case 64: return "locobasic"
		Case 65: return "lolcode"
		Case 66: return "lotusformulas"
		Case 67: return "lotusscript"
		Case 68: return "lscript"
		Case 69: return "lua"
		Case 70: return "m68k"
		Case 71: return "make"
		Case 72: return "matlab"
		Case 73: return "matlab"
		Case 74: return "mirc"
		Case 75: return "modula3"
		Case 76: return "mpasm"
		Case 77: return "mxml"
		Case 78: return "mysql"
		Case 79: return "text"
		Case 80: return "nsis"
		Case 81: return "oberon2"
		Case 82: return "objc"
		Case 83: return "ocaml-brief"
		Case 84: return "ocaml"
		Case 85: return "glsl"
		Case 86: return "oobas"
		Case 87: return "oracle11"
		Case 88: return "oracle8"
		Case 89: return "pascal"
		Case 90: return "pawn"
		Case 91: return "per"
		Case 92: return "perl"
		Case 93: return "php"
		Case 94: return "php-brief"
		Case 95: return "pic16"
		Case 96: return "pixelbender"
		Case 97: return "plsql"
		Case 98: return "povray"
		Case 99: return "powershell"
		Case 100: return "progress"
		Case 101: return "prolog"
		Case 102: return "properties"
		Case 103: return "providex"
		Case 104: return "python"
		Case 105: return "qbasic"
		Case 106: return "rails"
		Case 107: return "rebol"
		Case 108: return "reg"
		Case 109: return "robots"
		Case 110: return "ruby"
		Case 111: return "gnuplot"
		Case 112: return "sas"
		Case 113: return "scala"
		Case 114: return "scheme"
		Case 115: return "scilab"
		Case 116: return "sdlbasic"
		Case 117: return "smalltalk"
		Case 118: return "smarty"
		Case 119: return "sql"
		Case 120: return "tsql"
		Case 121: return "tcl"
		Case 122: return "tcl"
		Case 123: return "teraterm"
		Case 124: return "thinbasic"
		Case 125: return "typoscript"
		Case 126: return "unreal"
		Case 127: return "vbnet"
		Case 128: return "verilog"
		Case 129: return "vhdl"
		Case 130: return "vim"
		Case 131: return "visualprolog"
		Case 132: return "vb"
		Case 133: return "visualfoxpro"
		Case 134: return "whitespace"
		Case 135: return "whois"
		Case 136: return "winbatch"
		Case 137: return "xml"
		Case 138: return "xorg_conf"
		Case 139: return "xpp"
		Case 140: return "z80"
		Case Else: Return ""
	End Select
End Function


Function ExpByID(ByVal id As Integer) As String
	Select Case id
		Case 0: Return "N"
		Case 1: Return "10M"
		Case 2: Return "1H"
		Case 3: Return "1D"
		Case 4: Return "1M"
	End Select
End Function


Sub FillCBs(ByVal hWin As HWND)
	Dim tmpStr As String
	
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ABAP"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ActionScript"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ActionScript 3"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Ada"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Apache Log"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"AppleScript"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"APT Sources"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ASM (NASM)"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ASP"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"AutoIt"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Avisynth"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Bash"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Basic4GL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"BibTeX"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Blitz Basic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"BNF"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"BOO"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"BrainFuck"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"C"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"C for Macs"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"C Intermediate Language"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"C#"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"C++"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"CAD DCL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"CAD Lisp"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"CFDG"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Clone C"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Clone C++"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"CMake"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"COBOL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ColdFusion"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"CSS"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"D"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"DCS"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Delphi"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Diff"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"DIV"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"DOS"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"DOT"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Eiffel"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Email"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Erlang"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"FO Language"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Fortran"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"FreeBasic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Game Maker"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Genero"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"GetText"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Groovy"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Haskell"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"HQ9 Plus"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"HTML"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"IDL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"INI file"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Inno Script"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"INTERCAL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"IO"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Java"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Java 5"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"JavaScript"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"KiXtart"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Latex"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Linden Scripting"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Lisp"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Loco Basic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"LOL Code"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Lotus Formulas"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Lotus Script"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"LScript"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Lua"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"M68000 Assembler"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Make"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"MatLab"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"MatLab"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"mIRC"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Modula 3"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"MPASM"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"MXML"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"MySQL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"None"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"NullSoft Installer"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Oberon 2"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Objective C"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"OCalm Brief"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"OCaml"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"OpenGL Shading"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Openoffice BASIC"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Oracle 11"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Oracle 8"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Pascal"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"PAWN"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Per"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Perl"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"PHP"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"PHP Brief"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Pic 16"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Pixel Bender"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"PL/SQL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"POV-Ray"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Power Shell"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Progress"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Prolog"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Properties"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"ProvideX"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Python"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"QBasic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Rails"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"REBOL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"REG"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Robots"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Ruby"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Ruby Gnuplot"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"SAS"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Scala"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Scheme"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Scilab"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"SdlBasic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Smalltalk"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Smarty"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"SQL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"T-SQL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"TCL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"TCL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Tera Term"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"thinBasic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"TypoScript"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"unrealScript"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"VB.NET"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"VeriLog"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"VHDL"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"VIM"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Visual Pro Log"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"VisualBasic"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"VisualFoxPro"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"WhiteSpace"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"WHOIS"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Win Batch"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"XML"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Xorg Config"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"XPP"))
	SendDlgItemMessage(hWin, IDC_FORMAT, CB_ADDSTRING, 0, Cast(LPARAM, @"Z80 Assembler"))
	
	tmpStr = TT("Never", "Exp_never")
	SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	tmpStr = TT("10 Minutes", "Exp_10min")
	SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	tmpStr = TT("1 Hour", "Exp_1hour")
	SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	tmpStr = TT("1 Day", "Exp_1day")
	SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	tmpStr = TT("1 Month", "Exp_1month")
	SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	
	tmpStr = TT("Public", "Exp_public")
	SendDlgItemMessage(hWin, IDC_EXPOSURE, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	tmpStr = TT("Private", "Exp_private")
	SendDlgItemMessage(hWin, IDC_EXPOSURE, CB_ADDSTRING, 0, Cast(LPARAM, StrPtr(tmpStr)))
	
End Sub



Function NoPasteProc(byval hWin as HWND,byval uMsg as UINT,byval wParam as WPARAM,byval lParam as LPARAM) as integer
	Dim rc as RECT
	Dim tmpStr As String
	Dim tmpStr2 As String
	Dim q As Integer
	Dim w As Integer
	Dim sel As Integer
	Dim hMem as HGLOBAL
	Dim chrg as CHARRANGE
	Dim hMenuUpload As HMENU = 0
	Dim pt As POINT

	Select Case uMsg
		case WM_INITDIALOG
			MoveWindow(hWin, WinPos.left, WinPos.top, WinPos.right-WinPos.left, WinPos.bottom-WinPos.top, FALSE)
			lpFunctions->TranslateAddinDialog(hWin, "NoPaste")
			tmpStr = TT("Pastebin.com - NoPaste plugin", "1100")
			SetWindowText(hWin, StrPtr(tmpStr))
			
			lpOldEditProc = Cast(Any Ptr, SendMessage(GetDlgItem(hWin, IDC_RAEDIT), REM_SUBCLASS, 0, Cast(LPARAM, @EditProc)))
			hWinMenu = hWin
			FillCBs(hWin)
			
			SendDlgItemMessage(hWin, IDC_RAEDIT, REM_SETFONT, 0, Cast(LPARAM, @lpHandles->rafnt))
			SendDlgItemMessage(hWin, IDC_RAEDIT, REM_SETCOLOR, 0, Cast(LPARAM, lpData->lpFBCOLOR))
			SendDlgItemMessage(hWin, IDC_RAEDIT, REM_SELBARWIDTH, 10, 0)
			CheckDlgButton(GetDlgItem(hWin, IDC_RAEDIT), -2, TRUE)			'Show line numbers
			SendDlgItemMessage(hWin, IDC_RAEDIT, WM_COMMAND, -2, 0)
			
			SendDlgItemMessage(hWin, IDC_FORMAT, CB_SETCURSEL, Post.fmt, 0)
			SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_SETCURSEL, Post.expiration, 0)
			SendDlgItemMessage(hWin, IDC_EXPOSURE, CB_SETCURSEL, Post.exposure, 0)
			SendDlgItemMessage(hWin, IDC_TITLE, WM_SETTEXT, 0, Cast(LPARAM, Post.title))
			SendDlgItemMessage(hWin, IDC_EMAIL, WM_SETTEXT, 0, Cast(LPARAM, Post.email))
			SendDlgItemMessage(hWin, IDC_SUBDOMAIN, WM_SETTEXT, 0, Cast(LPARAM, Post.subdomain))
			
			If lpHandles->hred <> 0 AndAlso lpHandles->hred <> lpHandles->hres Then
				q = SendMessage(lpHandles->hred, WM_GETTEXTLENGTH, 0, 0)
				If q > 0 Then
					SendMessage(lpHandles->hred, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
					if chrg.cpMin=chrg.cpMax then
						q += 1
						hMem = GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT, q)
						SendMessage(lpHandles->hred, WM_GETTEXT, q-1, Cast(LPARAM, hMem))
					else
						q = chrg.cpMax-chrg.cpMin+1
						hMem = GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT, q)
						SendMessage(lpHandles->hred, EM_GETSELTEXT, 0, Cast(LPARAM, hMem))
					endif
					SendDlgItemMessage(hWin, IDC_RAEDIT, WM_SETTEXT, 0, Cast(LPARAM, hMem))
					GlobalFree(hMem)
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
				End If
			End If
			
			SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
			SendDlgItemMessage(hWin, IDC_EMAIL, EM_SETMODIFY, FALSE, 0)
			SendDlgItemMessage(hWin, IDC_SUBDOMAIN, EM_SETMODIFY, FALSE, 0)
			
		case WM_CLOSE
			If SendDlgItemMessage(hWin, IDC_RAEDIT, EM_GETMODIFY, 0, 0) <> 0 OrElse SendDlgItemMessage(hWin, IDC_TITLE, EM_GETMODIFY, 0, 0) <> 0 _ 
				OrElse SendDlgItemMessage(hWin, IDC_EMAIL, EM_GETMODIFY, 0, 0) <> 0 OrElse SendDlgItemMessage(hWin, IDC_SUBDOMAIN, EM_GETMODIFY, 0, 0) <> 0 Then _
				If tMsgBox(hWin, "Do you really want to discard your changes?", "discard_changes",,,MB_YESNOCANCEL Or MB_ICONQUESTION) <> IDYES Then Exit Select
			GetWindowRect(hWin, @WinPos)
			hWinMenu = 0
			If hMenuUpload <> 0 Then DestroyMenu(hMenuUpload)
			EndDialog(hWin, 0)
			
		case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDC_CLOSE
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
				Case IDC_UPLOAD
					
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_RAEDIT)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_RAEDIT), StrPtr(tmpStr), Len(tmpStr))		'RAEdit does not include null byte in length
					If Trim(tmpStr) = "" Then tMsgBox(hWin, "Code field is empty. Please enter some text!", "code_empty", "Error", "error", MB_OK Or MB_ICONWARNING) : Exit Select
					tmpStr2 = "paste_code=" & URLEncode(ANSI2UTF8(tmpStr))
					
					If Sett.onUpload = 0 Then
						If hMenuUpload <> 0 Then DestroyMenu(hMenuUpload)
						hMenuUpload = CreatePopupMenu()
						AppendMenu(hMenuUpload, MF_STRING, IDC_RBCLIPBOARD, TT("Copy post URL to clipboard", Str(IDC_RBCLIPBOARD)))
						AppendMenu(hMenuUpload, MF_STRING, IDC_RBBROWSER, TT("Open post in browser", Str(IDC_RBBROWSER)))
						AppendMenu(hMenuUpload, MF_STRING, IDC_RBBOTH, TT("Copy URL to clipboard and open in browser", Str(IDC_RBBOTH)))
						pt.x = 0
						pt.y = 0
						ClientToScreen(GetDlgItem(hWin, IDC_UPLOAD), @pt)
						sel = TrackPopupMenuEx(hMenuUpload, TPM_RETURNCMD Or TPM_BOTTOMALIGN, pt.x, pt.y, hWin, 0)
						If sel = 0 Then Exit Select
					EndIf
					
					tmpStr = FmtByID(SendDlgItemMessage(hWin, IDC_FORMAT, CB_GETCURSEL, 0, 0))
					If tmpStr <> "" Then tmpStr2 &= "&paste_format=" & URLEncode(tmpStr)
					
					tmpStr2 &= "&paste_private=" & Trim(Str(SendDlgItemMessage(hWin, IDC_EXPOSURE, CB_GETCURSEL, 0, 0)))
					
					tmpStr = ExpByID(SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_GETCURSEL, 0, 0))
					If tmpStr <> "" Then tmpStr2 &= "&paste_expire_date=" & URLEncode(tmpStr)
					
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_TITLE)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(tmpStr), Len(tmpStr)+1)
					If Trim(tmpStr) <> "" Then tmpStr2 &= "&paste_name=" & URLEncode(tmpStr)
					
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_SUBDOMAIN)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_SUBDOMAIN), StrPtr(tmpStr), Len(tmpStr)+1)
					If Trim(tmpStr) <> "" Then tmpStr2 &= "&paste_email=" & URLEncode(tmpStr)
					
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_SUBDOMAIN)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_SUBDOMAIN), StrPtr(tmpStr), Len(tmpStr)+1)
					If Trim(tmpStr) <> "" Then tmpStr2 &= "&paste_subdomain=" & URLEncode(tmpStr)
					
					If postHTTP(pbApiUrl, tmpStr2,, tmpStr) <> "" Then
						tMsgBox(hWin, "Error while establishing connection", "err_con", "Error", "error", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If Left(tmpStr,7)  <> "http://" Then
						MessageBox(hWin, TT("Error while uploading:", "err_upload") & CRLF & tmpStr, TT("Error", "error"), MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					tMsgBox(hWin, "Upload completed successfully", "success",,, MB_OK Or MB_ICONINFORMATION)
					
					If Sett.onUpload = 0 Then
						Select Case sel
							Case IDC_RBCLIPBOARD: SetClipboardText(tmpStr, hWin)
							Case IDC_RBBROWSER: ShellExecute(hWin, @"Open" , StrPtr(tmpStr) , NULL, NULL, SW_SHOWNORMAL)
							Case IDC_RBBOTH: SetClipboardText(tmpStr, hWin): ShellExecute(hWin, @"Open" , StrPtr(tmpStr) , NULL, NULL, SW_SHOWNORMAL)
						End Select
					Else
						If (Sett.onUpload And 1) <> 0 Then SetClipboardText(tmpStr, hWin)
						If (Sett.onUpload And 2) <> 0 Then ShellExecute(hWin, @"Open" , StrPtr(tmpStr) , NULL, NULL, SW_SHOWNORMAL)
					EndIf
					
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_EMAIL, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_SUBDOMAIN, EM_SETMODIFY, FALSE, 0)
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
					
				Case IDC_DEFAULT
					
					Post.fmt = SendDlgItemMessage(hWin, IDC_FORMAT, CB_GETCURSEL, 0, 0)
					Post.exposure = SendDlgItemMessage(hWin, IDC_EXPOSURE, CB_GETCURSEL, 0, 0)
					Post.expiration = SendDlgItemMessage(hWin, IDC_EXPIRATION, CB_GETCURSEL, 0, 0)
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_TITLE)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(tmpStr), Len(tmpStr)+1)
					*Post.title = tmpStr
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_EMAIL)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_EMAIL), StrPtr(tmpStr), Len(tmpStr)+1)
					*Post.email = tmpStr
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_SUBDOMAIN)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_SUBDOMAIN), StrPtr(tmpStr), Len(tmpStr)+1)
					*Post.subdomain = tmpStr
					SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_EMAIL, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_SUBDOMAIN, EM_SETMODIFY, FALSE, 0)
					
				Case IDC_ABOUT
					tmpStr = TT("NoPaste plugin", "nopaste_plugin") + CRLF + TT("FBedit plugin that allows quick publishing of source code at pastebin.com.", "desc") + CRLF + CRLF + "(c) 2011 Stefan Wurzinger" + CRLF + CRLF + "Version: " + prgVersion
					tmpStr2 = TT("About NoPaste plugin", "about")
					MessageBox(hWin, StrPtr(tmpStr), StrPtr(tmpStr2), MB_OK)
					
				Case IDC_SETTINGS
					DialogBoxParam(hInstance, Cast(ZString Ptr, IDD_SETTINGS), hWin, @SettingsProc, NULL)
					
				Case IDM_UNDO
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_UNDO, 0, 0)
					End If
					
				Case IDM_REDO
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_REDO, 0, 0)
					End If
					
				Case IDM_CUT
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_CUT, 0, 0)
					End If
				
				Case IDM_COPY
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_COPY, 0, 0)
					End If
				
				Case IDM_PASTE
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_PASTE, 0, 0)
					End If
				
				Case IDM_DELETE
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_REPLACESEL, TRUE, 0)
					End If
				
				Case IDM_SELECTALL
					If HiWord(wParam) = 0 Then
						chrg.cpMin = 0
						chrg.cpMax = -1
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_EXSETSEL, 0, Cast(LPARAM, @chrg))
					End If
					
				Case IDM_BLOCKCOMMENT
						IndentComment("'" & Chr(0), FALSE, GetDlgItem(hWin, IDC_RAEDIT))
							
				Case IDM_BLOCKUNCOMMENT
						IndentComment("'" & Chr(0), TRUE, GetDlgItem(hWin, IDC_RAEDIT))
					
				Case IDM_BLOCKINDENT
							IndentComment(Chr(9),FALSE, GetDlgItem(hWin, IDC_RAEDIT))
					
				Case IDM_BLOCKOUTDENT
						IndentComment(Chr(9),TRUE, GetDlgItem(hWin, IDC_RAEDIT))
					
			End Select
			
		Case WM_SIZE
			GetClientRect(hWin, @rc)
			
			MoveWindow(GetDlgItem(hWin, IDC_STITLE), rc.left + 285, rc.bottom + -112, 68, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_TITLE), rc.left + 358, rc.bottom + -117, rc.right - rc.left + -372, 20, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_RAEDIT), rc.left + 9, rc.top + 10, rc.right - rc.left + -18, rc.bottom - rc.top + -132, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_UPLOAD), rc.right + -181, rc.bottom + -34, 86, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_CLOSE), rc.right + -91, rc.bottom + -34, 82, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_ABOUT), rc.left + 9, rc.bottom + -34, 127, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SETTINGS), rc.left + 140, rc.bottom + -34, 86, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SFORMAT), rc.left + 14, rc.bottom + -112, 107, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_FORMAT), rc.left + 122, rc.bottom + -117, 140, 190, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SEXPIRATION), rc.left + 14, rc.bottom + -88, 107, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SEXPOSURE), rc.left + 14, rc.bottom + -63, 107, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_EXPIRATION), rc.left + 122, rc.bottom + -93, 140, 122, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_EXPOSURE), rc.left + 122, rc.bottom + -68, 140, 83, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_EMAIL), rc.left + 358, rc.bottom + -93, rc.right - rc.left + -372, 20, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SEMAIL), rc.left + 285, rc.bottom + -88, 68, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SUBDOMAIN), rc.left + 358, rc.bottom + -68, rc.right - rc.left + -372, 20, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SSUBDOMAIN), rc.left + 285, rc.bottom + -63, 68, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_DEFAULT), rc.left + 231, rc.bottom + -34, 100, 24, FALSE)
			
			InvalidateRect(hWin, @rc, TRUE)
			
			
		Case WM_INITMENUPOPUP
			If wParam = hContextMenu Then UpdMenu(hWin)
			
		Case Else
			Return FALSE
			
	End Select
	Return TRUE
	
End Function

'param = 1 - Alle MessageBoxes anzeigen; param = 0 - Nur Update-Meldung
Sub UpdateThread(param As Any Ptr)
	
	Dim Daten As XML
	Dim xmlnode As XML Ptr
	Dim xmlnode2 As XML Ptr
	Dim tmpStr As String
	Dim tmpStr2 As String
	
	If getHTTP(prgUpdateUrl, tmpStr) <> "" Then
		If param = 1 Then tMsgBox(lpHandles->hwnd, "Error while establishing connection to update-server", "err_upd_con", "Error", "error", MB_OK Or MB_ICONERROR)
		Exit Sub
	End If
	If Daten.Parse(tmpStr) <> 0 Then
		If param = 1 Then TMsgBox(0, "Error while parsing update-data (Invalid XML data)", "err_upd_xml", "Error", "error", MB_OK Or MB_ICONERROR)
		Exit Sub
	End If
	xmlnode = Daten.GetSubTag("version")
	If xmlnode = 0 Then
		If param = 1 Then TMsgBox(0, "Error while parsing update-data (Version number not found)", "err_upd_ver", "Error", "error", MB_OK Or MB_ICONERROR)
		Exit Sub
	End If
	xmlnode2 = Daten.GetSubTag("url")
	If prgVersion <> xmlnode->Daten Then
		If xmlnode2 = 0 Then
			tmpStr = TT("An update is available for your version of the NoPaste plugin.", "upd_msg1") + CRLF + CRLF + TT("Your current version is: ", "upd_curver") + prgVersion + CRLF + TT("The lastest version is: ", "upd_newver") + xmlnode->Daten + CRLF + CRLF + TT("Please keep your plugin up to date to ensure reliability in future", "upd_msg2")
			tmpStr2 = TT("NoPaste plugin", "nopaste_plugin") + " - " + TT("Update available", "upd_avail")
			MessageBox(lpHandles->hwnd, StrPtr(tmpStr), StrPtr(tmpStr2), MB_OK Or MB_ICONINFORMATION)
		Else
			tmpStr = TT("An update is available for your version of the NoPaste plugin.", "upd_msg1") + CRLF + CRLF + TT("Your current version is: ", "upd_curver") + prgVersion + CRLF + TT("The lastest version is: ", "upd_newver") + xmlnode->Daten + CRLF + CRLF + TT("Please keep your plugin up to date to ensure reliability in future", "upd_msg2") + CRLF + CRLF + TT("Do you want to open the homepage now to download the latest version?", "upd_now")
			tmpStr2 = TT("NoPaste plugin", "nopaste_plugin") + " - " + TT("Update available", "upd_avail")
			If MessageBox(lpHandles->hwnd,  StrPtr(tmpStr), StrPtr(tmpStr2), MB_YESNO Or MB_ICONQUESTION) = IDYES Then _
				ShellExecute(lpHandles->hwnd, @"open" , StrPtr(xmlnode2->Daten) , NULL, NULL, SW_SHOWNORMAL)
		End If
	Else
		If param = 1 Then tMsgBox(lpHandles->hwnd, "Your version of the NoPaste plugin is up to date", "upd_uptodate",,, MB_OK Or MB_ICONINFORMATION)
	End If
	
	tUpdate = 0
	
End Sub



Function InstallDll CDECL alias "InstallDll" (byval hWin as HWND,byval hInst as HINSTANCE) as ADDINHOOKS ptr EXPORT

	hInstance = hInst
	lpHandles = Cast(ADDINHANDLES ptr, SendMessage(hWin, AIM_GETHANDLES, 0, 0))
	lpData = Cast(ADDINDATA ptr, SendMessage(hWin, AIM_GETDATA, 0, 0))
	lpFunctions = Cast(ADDINFUNCTIONS ptr, SendMessage(hWin,AIM_GETFUNCTIONS, 0, 0))
	
	IDM_NOPASTE = SendMessage(hWin, AIM_GETMENUID, 0, 0)
	IDM_SETTINGS = SendMessage(hWin, AIM_GETMENUID, 0, 0)
	AddToMenu(IDM_NOPASTE, IDM_TOOLS, TT("NoPaste (pastebin.com)", "menu_nopaste"))
	AddToMenu(IDM_SETTINGS, IDM_OPTIONS, TT("NoPaste options", "menu_options"))
	
	hContextMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_CONTEXTMENU))
	TranslateMenu(hContextMenu)
	
	lpFunctions->LoadFromIni("NoPaste", "WinPos", "4444", @WinPos, FALSE)
	Post.title = Allocate(255)
	Post.email = Allocate(255)
	Post.subdomain = Allocate(255)
	*Post.title = ""
	*Post.email = ""
	*Post.subdomain = ""
	lpFunctions->LoadFromIni("NoPaste", "PostDefaults", "444000", @Post, FALSE)
	lpFunctions->LoadFromIni("NoPaste", "Settings", "444", @Sett, FALSE)
	
	UpdateAccelerator(TranslateModifiers(HiByte(Sett.hotkey)) Or FVIRTKEY or FNOINVERT, LoByte(Sett.hotkey), IDM_NOPASTE)

	netStart()
	If Sett.updates <> 0 Then If tUpdate = 0 Then tUpdate = ThreadCreate(@UpdateThread)
	
	Dim icex As InitCommonControlsEx
	icex.dwSize = sizeof(INITCOMMONCONTROLSEX)
	icex.dwICC = ICC_USEREX_CLASSES
	InitCommonControlsEx(@icex)
	
	hooks.hook1=HOOK_COMMAND or HOOK_CLOSE
	hooks.hook2=0
	hooks.hook3=0
	hooks.hook4=0
	return @hooks

End Function

Function DllFunction CDECL alias "DllFunction" (byval hWin as HWND,byval uMsg as UINT,byval wParam as WPARAM,byval lParam as LPARAM) as bool EXPORT
	Select Case uMsg
		Case AIM_COMMAND
		
			If LoWord(wParam) = IDM_NOPASTE Then
				DialogBoxParam(hInstance, Cast(ZString Ptr, IDD_NOPASTE), hWin, @NoPasteProc, NULL)
			EndIf
			If LoWord(wParam) = IDM_SETTINGS Then
				DialogBoxParam(hInstance, Cast(ZString Ptr, IDD_SETTINGS), hWin, @SettingsProc, NULL)
			EndIf
						
		Case AIM_CLOSE
			netStop()
			lpFunctions->SaveToIni("NoPaste", "WinPos", "4444", @WinPos, FALSE)
			lpFunctions->SaveToIni("NoPaste", "PostDefaults", "444000", @Post, FALSE)
			DeAllocate(Post.title)
			DeAllocate(Post.email)
			DeAllocate(Post.subdomain)
			lpFunctions->SaveToIni("NoPaste", "Settings", "444", @Sett, FALSE)
			DestroyMenu(hContextMenu)

	end select
	return FALSE
End Function
